#include "ryhmatoo.h"

int main(void)
{
    int word_i = -1, char_i = 0;
    int word_count = 0;
    
    char words[MAX_WORD_COUNT][WORD_LEN];
    
    FILE *fp = fopen("lahtefail.txt", "r");
    
    separate(words, word_i, char_i, fp);
    word_count = word_i+1;
    sort_words(words, word_count);
    output(words, word_count, word_i);
    
    return 0;
}
void separate(char words[MAX_WORD_COUNT][WORD_LEN], int word_i, int char_i, FILE *fp)
{
    char current_char, last_char = '\n';
	while((current_char = fgetc(fp)) != EOF){
        if(last_char == ' ' || last_char == '.' || last_char == '\n' ||
                last_char == ','){
            
            if(current_char != ' ' && current_char != '.' &&
                    current_char != '\n' && current_char != ','){

                if(word_i != -1){
                    words[word_i][char_i] = '\0';
                }
                word_i++;
                
                char_i = 0; 
                words[word_i][char_i] = current_char; 
                char_i++;
            }
        }else if(current_char != ' ' && current_char != '.' && 
                current_char != '\n' && current_char != ','){

            words[word_i][char_i] = current_char;
            char_i++;
        }

        last_char = current_char;
    }
}

void sort_words(char words[MAX_WORD_COUNT][WORD_LEN], int word_count)
{
    int i, j;
    char temp[WORD_LEN];

    for(i = 0; i < word_count-1; i++){
        for(j = i+1; j < word_count; j++){
            if(strcmp(words[i], words[j]) > 0){
                strcpy(temp, words[i]);
                strcpy(words[i], words[j]);
                strcpy(words[j], temp);
            }
        }
    }
}

void output(char words[MAX_WORD_COUNT][WORD_LEN], int word_count, int word_i)
{
	printf("Total words: %d", word_count);
    for(word_i = 0; word_i < word_count; word_i++){
        if(word_i % 10 == 0){ 
            printf("\n");
        }
        
        if(word_i+1 != word_count){
            printf("%s, ", words[word_i]);
        }else{
            printf("%s\n", words[word_i]);
        }
    }
}
